package demo.tablecellrenderer.renderer;

import java.awt.Component;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class IconRenderer implements TableCellRenderer
{
  private TableCellRenderer delegate;
  private Icon icon;

  public IconRenderer(TableCellRenderer defaultRenderer)
  {
    this.delegate = defaultRenderer;
    icon = new ImageIcon(this.getClass().getResource("/demo/tablecellrenderer/accept.png"));
  }

  public Component getTableCellRendererComponent(JTable table, Object value, 
                           boolean isSelected, boolean hasFocus, int row, int column) 
  {
    Component c = delegate.getTableCellRendererComponent(table, value, isSelected, 
                                                                hasFocus, row, column);
    if (c instanceof JLabel && (Double)value*1000 % 50 == 0)
      ((JLabel)c).setIcon(icon);
    //if (c instanceof JLabel)
      //((JLabel)c).setIcon((Double)value*1000 % 50 == 0 ? icon : null);
    return c;
  }
} 
