package demo.tablecellrenderer.renderer;

import java.awt.Component;
import java.text.NumberFormat;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class PercentageRenderer implements TableCellRenderer
{
  private TableCellRenderer delegate;
  private NumberFormat formatter;

  public PercentageRenderer(TableCellRenderer defaultRenderer)
  {
    this.delegate = defaultRenderer;
    formatter = NumberFormat.getPercentInstance();
  }

  public Component getTableCellRendererComponent(JTable table, Object value, 
                           boolean isSelected, boolean hasFocus, int row, int column) 
  {
    Component c = delegate.getTableCellRendererComponent(table, value, isSelected, 
                                                                hasFocus, row, column);
    String s = formatter.format((Double)value);
    if (c instanceof JLabel)
      ((JLabel)c).setText(s);
    return c;
  }
} 
