package demo.tablecellrenderer.renderer;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class SimpleColumnBackgroundRenderer implements TableCellRenderer
{
  private TableCellRenderer delegate;

  public SimpleColumnBackgroundRenderer(TableCellRenderer defaultRenderer)
  {
    this.delegate = defaultRenderer;
  }

  public Component getTableCellRendererComponent(JTable table, Object value, 
                           boolean isSelected, boolean hasFocus, int row, int column) 
  {
    Component c = delegate.getTableCellRendererComponent(table, value, isSelected, 
                                                                hasFocus, row, column);      
    if (!isSelected)
      c.setBackground(new Color(0xFFF0E0));
    return c;
  }
} 