package demo.tablecellrenderer.renderer;

import java.awt.BorderLayout;
import java.awt.Component;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.table.TableCellRenderer;

import de.javasoft.plaf.synthetica.SyntheticaLookAndFeel;

@SuppressWarnings("serial")
public class SpinnerRenderer extends JLabel implements TableCellRenderer
{
  protected TableCellRenderer delegate;
  protected JSpinner spinner;

  public SpinnerRenderer(TableCellRenderer defaultRenderer)
  {
    delegate = defaultRenderer;
    //identifies TableCellRenderer
    setName("Table.cellRenderer");
    setLayout(new BorderLayout());
    
    spinner = new JSpinner();   
    //remove component border
    spinner.setBorder(new EmptyBorder(0,0,0,0));
    //disable component background painting
    spinner.putClientProperty("Synthetica.opaque", false);
    add(spinner);
  }
  
  public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
  {
    JComponent c = (JComponent)delegate.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
    //respect insets and focus
    setBorder(c.getBorder());
    //copy opacity
    setOpaque(c.isOpaque());
    //apply background
    setBackground(c.getBackground());
    
    //apply foreground
    Component editor = SyntheticaLookAndFeel.findComponent(JTextField.class, spinner);
    editor.setForeground(c.getForeground());
    
    spinner.setValue(value);
    return this;
  }  
}